git-am.sh 16.4 KB
Newer Older
1 2
#!/bin/sh
#
3
# Copyright (c) 2005, 2006 Junio C Hamano
4

5
SUBDIRECTORY_OK=Yes
6 7
OPTIONS_KEEPDASHDASH=
OPTIONS_SPEC="\
J
Junio C Hamano 已提交
8
git am [options] [<mbox>|<Maildir>...]
9
git am [options] (--resolved | --skip | --abort)
10
--
11
i,interactive   run interactively
J
Jay Soffian 已提交
12
b,binary*       (historical option -- no-op)
13
3,3way          allow fall back on 3way merging if needed
S
Stephen Boyd 已提交
14
q,quiet         be quiet
15 16
s,signoff       add a Signed-off-by line to the commit message
u,utf8          recode into utf8 (default)
17
k,keep          pass -k flag to git-mailinfo
18
whitespace=     pass it through git-apply
19
directory=      pass it through git-apply
20 21
C=              pass it through git-apply
p=              pass it through git-apply
22
patch-format=   format the patch(es) are in
23
reject          pass it through git-apply
24 25
resolvemsg=     override error message when patch failure occurs
r,resolved      to be used after a patch failure
J
Junio C Hamano 已提交
26
skip            skip the current patch
N
Nanako Shiraishi 已提交
27
abort           restore the original branch and abort the patching operation.
28
committer-date-is-author-date    lie about committer date
29
ignore-date     use current timestamp for author date
J
Jay Soffian 已提交
30
rebasing*       (internal use for git-rebase)"
31

32
. git-sh-setup
33
prefix=$(git rev-parse --show-prefix)
34
set_reflog_action am
35
require_work_tree
36
cd_to_toplevel
37

38 39
git var GIT_COMMITTER_IDENT >/dev/null ||
	die "You need to set your committer info first"
40

41 42 43 44 45 46 47
if git rev-parse --verify -q HEAD >/dev/null
then
	HAS_HEAD=yes
else
	HAS_HEAD=
fi

48
sq () {
49
	git rev-parse --sq-quote "$@"
50 51
}

52 53 54 55 56
stop_here () {
    echo "$1" >"$dotest/next"
    exit 1
}

57
stop_here_user_resolve () {
58
    if [ -n "$resolvemsg" ]; then
J
Jeff King 已提交
59
	    printf '%s\n' "$resolvemsg"
60 61
	    stop_here $1
    fi
62
    cmdline="git am"
63 64 65 66 67 68 69 70 71 72
    if test '' != "$interactive"
    then
        cmdline="$cmdline -i"
    fi
    if test '' != "$threeway"
    then
        cmdline="$cmdline -3"
    fi
    echo "When you have resolved this problem run \"$cmdline --resolved\"."
    echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
N
Nanako Shiraishi 已提交
73
    echo "To restore the original branch and stop patching run \"$cmdline --abort\"."
74 75 76 77

    stop_here $1
}

78 79 80 81 82 83 84
go_next () {
	rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
		"$dotest/patch" "$dotest/info"
	echo "$next" >"$dotest/next"
	this=$next
}

85 86 87 88 89 90
cannot_fallback () {
	echo "$1"
	echo "Cannot fall back to three-way merge."
	exit 1
}

91 92 93 94 95 96 97
fall_back_3way () {
    O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`

    rm -fr "$dotest"/patch-merge-*
    mkdir "$dotest/patch-merge-tmp-dir"

    # First see if the patch records the index info that we can use.
98 99
    git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
	"$dotest/patch" &&
100
    GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
101
    git write-tree >"$dotest/patch-merge-base+" ||
102
    cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
103

S
Stephen Boyd 已提交
104
    say Using index info to reconstruct a base tree...
105
    if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
S
Stephan Beyer 已提交
106
	git apply --cached <"$dotest/patch"
107 108 109
    then
	mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
	mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
110 111 112
    else
        cannot_fallback "Did you hand edit your patch?
It does not apply to blobs recorded in its index."
113 114 115
    fi

    test -f "$dotest/patch-merge-index" &&
116
    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
117 118 119
    orig_tree=$(cat "$dotest/patch-merge-base") &&
    rm -fr "$dotest"/patch-merge-* || exit 1

S
Stephen Boyd 已提交
120
    say Falling back to patching base and 3-way merge...
121 122 123 124

    # This is not so wrong.  Depending on which base we picked,
    # orig_tree may be wildly different from ours, but his_tree
    # has the same set of wildly different changes in parts the
125
    # patch did not touch, so recursive ends up canceling them,
126 127
    # saying that we reverted all those changes.

128
    eval GITHEAD_$his_tree='"$FIRSTLINE"'
129
    export GITHEAD_$his_tree
S
Stephen Boyd 已提交
130 131 132 133
    if test -n "$GIT_QUIET"
    then
	    export GIT_MERGE_VERBOSITY=0
    fi
134
    git-merge-recursive $orig_tree -- HEAD $his_tree || {
135
	    git rerere
136 137 138
	    echo Failed to merge in the changes.
	    exit 1
    }
139
    unset GITHEAD_$his_tree
140 141
}

142 143 144 145 146 147
clean_abort () {
	test $# = 0 || echo >&2 "$@"
	rm -fr "$dotest"
	exit 1
}

148 149 150 151 152 153 154 155
patch_format=

check_patch_format () {
	# early return if patch_format was set from the command line
	if test -n "$patch_format"
	then
		return 0
	fi
156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193

	# we default to mbox format if input is from stdin and for
	# directories
	if test $# = 0 || test "x$1" = "x-" || test -d "$1"
	then
		patch_format=mbox
		return 0
	fi

	# otherwise, check the first few lines of the first patch to try
	# to detect its format
	{
		read l1
		read l2
		read l3
		case "$l1" in
		"From "* | "From: "*)
			patch_format=mbox
			;;
		'# This series applies on GIT commit'*)
			patch_format=stgit-series
			;;
		"# HG changeset patch")
			patch_format=hg
			;;
		*)
			# if the second line is empty and the third is
			# a From, Author or Date entry, this is very
			# likely an StGIT patch
			case "$l2,$l3" in
			,"From: "* | ,"Author: "* | ,"Date: "*)
				patch_format=stgit
				;;
			*)
				;;
			esac
			;;
		esac
194
	} < "$1" || clean_abort
195 196 197 198 199
}

split_patches () {
	case "$patch_format" in
	mbox)
200 201
		git mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||
		clean_abort
202
		;;
203 204 205
	stgit-series)
		if test $# -ne 1
		then
206
			clean_abort "Only one StGIT patch series can be applied at once"
207 208 209 210 211 212 213 214 215 216 217 218 219 220
		fi
		series_dir=`dirname "$1"`
		series_file="$1"
		shift
		{
			set x
			while read filename
			do
				set "$@" "$series_dir/$filename"
			done
			# remove the safety x
			shift
			# remove the arg coming from the first-line comment
			shift
221
		} < "$series_file" || clean_abort
222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249
		# set the patch format appropriately
		patch_format=stgit
		# now handle the actual StGIT patches
		split_patches "$@"
		;;
	stgit)
		this=0
		for stgit in "$@"
		do
			this=`expr "$this" + 1`
			msgnum=`printf "%0${prec}d" $this`
			# Perl version of StGIT parse_patch. The first nonemptyline
			# not starting with Author, From or Date is the
			# subject, and the body starts with the next nonempty
			# line not starting with Author, From or Date
			perl -ne 'BEGIN { $subject = 0 }
				if ($subject > 1) { print ; }
				elsif (/^\s+$/) { next ; }
				elsif (/^Author:/) { print s/Author/From/ ; }
				elsif (/^(From|Date)/) { print ; }
				elsif ($subject) {
					$subject = 2 ;
					print "\n" ;
					print ;
				} else {
					print "Subject: ", $_ ;
					$subject = 1;
				}
250
			' < "$stgit" > "$dotest/$msgnum" || clean_abort
251 252 253 254 255
		done
		echo "$this" > "$dotest/last"
		this=
		msgnum=
		;;
256
	*)
257
		clean_abort "Patch format $patch_format is not supported."
258 259 260 261
		;;
	esac
}

262
prec=4
263
dotest="$GIT_DIR/rebase-apply"
264
sign= utf8=t keep= skip= interactive= resolved= rebasing= abort=
265
resolvemsg= resume=
M
Michael S. Tsirkin 已提交
266
git_apply_opt=
267
committer_date_is_author_date=
268
ignore_date=
269

270
while test $# != 0
271 272
do
	case "$1" in
273 274 275
	-i|--interactive)
		interactive=t ;;
	-b|--binary)
S
Stephan Beyer 已提交
276
		: ;;
277 278
	-3|--3way)
		threeway=t ;;
279
	-s|--signoff)
280 281 282 283 284 285 286 287 288 289 290
		sign=t ;;
	-u|--utf8)
		utf8=t ;; # this is now default
	--no-utf8)
		utf8= ;;
	-k|--keep)
		keep=t ;;
	-r|--resolved)
		resolved=t ;;
	--skip)
		skip=t ;;
N
Nanako Shiraishi 已提交
291 292
	--abort)
		abort=t ;;
J
Junio C Hamano 已提交
293
	--rebasing)
S
Stephan Beyer 已提交
294
		rebasing=t threeway=t keep=t ;;
295
	-d|--dotest)
296 297
		die "-d option is no longer supported.  Do not use."
		;;
298 299
	--resolvemsg)
		shift; resolvemsg=$1 ;;
300 301
	--whitespace|--directory)
		git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
302
	-C|-p)
303
		git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
304 305
	--patch-format)
		shift ; patch_format="$1" ;;
306 307
	--reject)
		git_apply_opt="$git_apply_opt $1" ;;
308 309
	--committer-date-is-author-date)
		committer_date_is_author_date=t ;;
310 311
	--ignore-date)
		ignore_date=t ;;
S
Stephen Boyd 已提交
312 313
	-q|--quiet)
		GIT_QUIET=t ;;
314
	--)
315
		shift; break ;;
316
	*)
317
		usage ;;
318
	esac
319
	shift
320 321
done

J
Junio C Hamano 已提交
322 323
# If the dotest directory exists, but we have finished applying all the
# patches in them, clear it out.
324 325 326 327 328 329 330 331 332 333 334
if test -d "$dotest" &&
   last=$(cat "$dotest/last") &&
   next=$(cat "$dotest/next") &&
   test $# != 0 &&
   test "$next" -gt "$last"
then
   rm -fr "$dotest"
fi

if test -d "$dotest"
then
N
Nanako Shiraishi 已提交
335
	case "$#,$skip$resolved$abort" in
J
Junio C Hamano 已提交
336 337 338 339 340 341 342
	0,*t*)
		# Explicit resume command and we do not have file, so
		# we are happy.
		: ;;
	0,)
		# No file input but without resume parameters; catch
		# user error to feed us a patch from standard input
343
		# when there is already $dotest.  This is somewhat
J
Junio C Hamano 已提交
344 345 346
		# unreliable -- stdin could be /dev/null for example
		# and the caller did not intend to feed us a patch but
		# wanted to continue unattended.
J
Jay Soffian 已提交
347
		test -t 0
J
Junio C Hamano 已提交
348 349 350 351 352
		;;
	*)
		false
		;;
	esac ||
353
	die "previous rebase directory $dotest still exists but mbox given."
354
	resume=yes
N
Nanako Shiraishi 已提交
355

356
	case "$skip,$abort" in
357 358 359
	t,t)
		die "Please make up your mind. --skip or --abort?"
		;;
360 361 362 363 364 365 366 367
	t,)
		git rerere clear
		git read-tree --reset -u HEAD HEAD
		orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
		git reset HEAD
		git update-ref ORIG_HEAD $orig_head
		;;
	,t)
368 369 370 371
		if test -f "$dotest/rebasing"
		then
			exec git rebase --abort
		fi
N
Nanako Shiraishi 已提交
372
		git rerere clear
373 374 375 376
		test -f "$dotest/dirtyindex" || {
			git read-tree --reset -u HEAD ORIG_HEAD
			git reset ORIG_HEAD
		}
N
Nanako Shiraishi 已提交
377 378 379
		rm -fr "$dotest"
		exit ;;
	esac
380
	rm -f "$dotest/dirtyindex"
381
else
N
Nanako Shiraishi 已提交
382 383
	# Make sure we are not given --skip, --resolved, nor --abort
	test "$skip$resolved$abort" = "" ||
384
		die "Resolve operation not in progress, we are not resuming."
385 386 387 388

	# Start afresh.
	mkdir -p "$dotest" || exit

389 390 391 392 393 394 395 396 397 398 399 400 401 402 403 404 405 406
	if test -n "$prefix" && test $# != 0
	then
		first=t
		for arg
		do
			test -n "$first" && {
				set x
				first=
			}
			case "$arg" in
			/*)
				set "$@" "$arg" ;;
			*)
				set "$@" "$prefix$arg" ;;
			esac
		done
		shift
	fi
407 408 409 410

	check_patch_format "$@"

	split_patches "$@"
411

S
Stephen Boyd 已提交
412
	# -s, -u, -k, --whitespace, -3, -C, -q and -p flags are kept
413
	# for the resuming session after a patch failure.
414
	# -i can and must be given when resuming.
415
	echo " $git_apply_opt" >"$dotest/apply-opt"
416
	echo "$threeway" >"$dotest/threeway"
417 418 419
	echo "$sign" >"$dotest/sign"
	echo "$utf8" >"$dotest/utf8"
	echo "$keep" >"$dotest/keep"
S
Stephen Boyd 已提交
420
	echo "$GIT_QUIET" >"$dotest/quiet"
421
	echo 1 >"$dotest/next"
J
Junio C Hamano 已提交
422 423 424 425 426
	if test -n "$rebasing"
	then
		: >"$dotest/rebasing"
	else
		: >"$dotest/applying"
427 428 429 430 431 432
		if test -n "$HAS_HEAD"
		then
			git update-ref ORIG_HEAD HEAD
		else
			git update-ref -d ORIG_HEAD >/dev/null 2>&1
		fi
J
Junio C Hamano 已提交
433
	fi
434 435
fi

J
Junio C Hamano 已提交
436 437
case "$resolved" in
'')
438 439 440 441 442 443
	case "$HAS_HEAD" in
	'')
		files=$(git ls-files) ;;
	?*)
		files=$(git diff-index --cached --name-only HEAD --) ;;
	esac || exit
444 445
	if test "$files"
	then
446
		test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
447 448
		die "Dirty index: cannot apply patches (dirty: $files)"
	fi
J
Junio C Hamano 已提交
449 450
esac

451 452 453
if test "$(cat "$dotest/utf8")" = t
then
	utf8=-u
454 455
else
	utf8=-n
456 457 458 459 460
fi
if test "$(cat "$dotest/keep")" = t
then
	keep=-k
fi
S
Stephen Boyd 已提交
461 462 463 464
if test "$(cat "$dotest/quiet")" = t
then
	GIT_QUIET=t
fi
465 466 467 468
if test "$(cat "$dotest/threeway")" = t
then
	threeway=t
fi
469
git_apply_opt=$(cat "$dotest/apply-opt")
470 471
if test "$(cat "$dotest/sign")" = t
then
472
	SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
473 474 475 476 477 478 479 480 481 482 483 484
			s/>.*/>/
			s/^/Signed-off-by: /'
		`
else
	SIGNOFF=
fi

last=`cat "$dotest/last"`
this=`cat "$dotest/next"`
if test "$skip" = t
then
	this=`expr "$this" + 1`
J
Jan Harkes 已提交
485
	resume=
486 487 488 489
fi

if test "$this" -gt "$last"
then
S
Stephen Boyd 已提交
490
	say Nothing to do.
491 492 493 494 495 496 497 498 499
	rm -fr "$dotest"
	exit
fi

while test "$this" -le "$last"
do
	msgnum=`printf "%0${prec}d" $this`
	next=`expr "$this" + 1`
	test -f "$dotest/$msgnum" || {
J
Jan Harkes 已提交
500
		resume=
501 502 503
		go_next
		continue
	}
J
Junio C Hamano 已提交
504 505 506 507 508 509 510 511 512

	# If we are not resuming, parse and extract the patch information
	# into separate files:
	#  - info records the authorship and title
	#  - msg is the rest of commit log message
	#  - patch is the patch body.
	#
	# When we are resuming, these files are either already prepared
	# by the user, or the user can tell us to do so by --resolved flag.
513 514
	case "$resume" in
	'')
515
		git mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
516 517
			<"$dotest/$msgnum" >"$dotest/info" ||
			stop_here $this
518 519 520 521 522 523

		# skip pine's internal folder data
		grep '^Author: Mail System Internal Data$' \
			<"$dotest"/info >/dev/null &&
			go_next && continue

524
		test -s "$dotest/patch" || {
525
			echo "Patch is empty.  Was it split wrong?"
526 527
			stop_here $this
		}
528 529 530 531 532 533 534 535 536 537 538
		if test -f "$dotest/rebasing" &&
			commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
				-e q "$dotest/$msgnum") &&
			test "$(git cat-file -t "$commit")" = commit
		then
			git cat-file commit "$commit" |
			sed -e '1,/^$/d' >"$dotest/msg-clean"
		else
			SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
			case "$keep_subject" in -k)  SUBJECT="[PATCH] $SUBJECT" ;; esac

539
			(printf '%s\n\n' "$SUBJECT"; cat "$dotest/msg") |
540 541
				git stripspace > "$dotest/msg-clean"
		fi
542 543
		;;
	esac
544 545 546 547

	GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
	GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
	GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
548

549
	if test -z "$GIT_AUTHOR_EMAIL"
550
	then
551
		echo "Patch does not have a valid e-mail address."
552 553 554
		stop_here $this
	fi

J
Junio C Hamano 已提交
555
	export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
556

557 558 559 560
	case "$resume" in
	'')
	    if test '' != "$SIGNOFF"
	    then
561
		LAST_SIGNED_OFF_BY=`
562 563
		    sed -ne '/^Signed-off-by: /p' \
		    "$dotest/msg-clean" |
564
		    sed -ne '$p'
565
		`
566 567
		ADD_SIGNOFF=`
		    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
568 569
		    test '' = "$LAST_SIGNED_OFF_BY" && echo
		    echo "$SIGNOFF"
570 571
		}`
	    else
572
		ADD_SIGNOFF=
573 574
	    fi
	    {
575 576 577 578 579 580 581 582
		if test -s "$dotest/msg-clean"
		then
			cat "$dotest/msg-clean"
		fi
		if test '' != "$ADD_SIGNOFF"
		then
			echo "$ADD_SIGNOFF"
		fi
583 584
	    } >"$dotest/final-commit"
	    ;;
J
Junio C Hamano 已提交
585
	*)
586
		case "$resolved$interactive" in
J
Junio C Hamano 已提交
587 588
		tt)
			# This is used only for interactive view option.
589
			git diff-index -p --cached HEAD -- >"$dotest/patch"
J
Junio C Hamano 已提交
590 591
			;;
		esac
592
	esac
593

594
	resume=
595 596
	if test "$interactive" = t
	then
597 598
	    test -t 0 ||
	    die "cannot be interactive without stdin connected to a terminal."
599 600 601 602 603 604 605
	    action=again
	    while test "$action" = again
	    do
		echo "Commit Body is:"
		echo "--------------------------"
		cat "$dotest/final-commit"
		echo "--------------------------"
J
Jason Riedy 已提交
606
		printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
607 608
		read reply
		case "$reply" in
609 610 611
		[yY]*) action=yes ;;
		[aA]*) action=yes interactive= ;;
		[nN]*) action=skip ;;
612
		[eE]*) git_editor "$dotest/final-commit"
613
		       action=again ;;
614 615 616
		[vV]*) action=again
		       LESS=-S ${PAGER:-less} "$dotest/patch" ;;
		*)     action=again ;;
617 618 619 620 621
		esac
	    done
	else
	    action=yes
	fi
622
	FIRSTLINE=$(sed 1q "$dotest/final-commit")
623 624 625 626 627 628 629 630 631 632 633 634 635

	if test $action = skip
	then
		go_next
		continue
	fi

	if test -x "$GIT_DIR"/hooks/applypatch-msg
	then
		"$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
		stop_here $this
	fi

S
Stephen Boyd 已提交
636
	say "Applying: $FIRSTLINE"
637

J
Junio C Hamano 已提交
638 639
	case "$resolved" in
	'')
640 641 642 643 644 645 646 647
		# When we are allowed to fall back to 3-way later, don't give
		# false errors during the initial attempt.
		squelch=
		if test "$threeway" = t
		then
			squelch='>/dev/null 2>&1 '
		fi
		eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
J
Junio C Hamano 已提交
648 649 650 651 652 653 654 655
		apply_status=$?
		;;
	t)
		# Resolved means the user did all the hard work, and
		# we do not have to do any patch application.  Just
		# trust what the user has in the index file and the
		# working tree.
		resolved=
656
		git diff-index --quiet --cached HEAD -- && {
657
			echo "No changes - did you forget to use 'git add'?"
658
			stop_here_user_resolve $this
659
		}
660
		unmerged=$(git ls-files -u)
661 662 663
		if test -n "$unmerged"
		then
			echo "You still have unmerged paths in your index"
664
			echo "did you forget to use 'git add'?"
665
			stop_here_user_resolve $this
666
		fi
J
Junio C Hamano 已提交
667
		apply_status=0
668
		git rerere
J
Junio C Hamano 已提交
669 670 671
		;;
	esac

672 673
	if test $apply_status = 1 && test "$threeway" = t
	then
674
		if (fall_back_3way)
675
		then
676 677
		    # Applying the patch to an earlier tree and merging the
		    # result may have produced the same tree as ours.
678
		    git diff-index --quiet --cached HEAD -- && {
S
Stephen Boyd 已提交
679
			say No changes -- Patch already applied.
680 681 682
			go_next
			continue
		    }
683 684
		    # clear apply_status -- we have successfully merged.
		    apply_status=0
685 686 687 688
		fi
	fi
	if test $apply_status != 0
	then
689
		printf 'Patch failed at %s %s\n' "$msgnum" "$FIRSTLINE"
690
		stop_here_user_resolve $this
691 692 693 694 695 696 697
	fi

	if test -x "$GIT_DIR"/hooks/pre-applypatch
	then
		"$GIT_DIR"/hooks/pre-applypatch || stop_here $this
	fi

698
	tree=$(git write-tree) &&
699
	commit=$(
700 701 702 703
		if test -n "$ignore_date"
		then
			GIT_AUTHOR_DATE=
		fi
704
		parent=$(git rev-parse --verify -q HEAD) ||
S
Stephen Boyd 已提交
705
		say >&2 "applying to an empty history"
706

707 708 709 710 711
		if test -n "$committer_date_is_author_date"
		then
			GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
			export GIT_COMMITTER_DATE
		fi &&
712
		git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
713
	) &&
714
	git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
715 716 717 718 719 720 721 722 723 724
	stop_here $this

	if test -x "$GIT_DIR"/hooks/post-applypatch
	then
		"$GIT_DIR"/hooks/post-applypatch
	fi

	go_next
done

725 726
git gc --auto

727
rm -fr "$dotest"